# Enum CallEndReason

java.lang.Object
java.lang.Enum<CallEndReason>
com.codename1.call.CallEndReason

All Implemented Interfaces:
  `Comparable<CallEndReason>`

public enum CallEndReason extends Enum<CallEndReason>

Why a call ended. This is what the system writes into the call log, so the value chosen is user-visible: a call reported as `REMOTE_ENDED` shows differently from one reported as `UNANSWERED`.

The ordinals cross the SPI boundary, so existing constants must not be reordered.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `BUSY`
  The far end was busy.
  `FAILED`
  The call could not be set up -- no network, signalling failure, or a far end that never answered the invitation.
  `FILTERED`
  The system, not the user, declined it: Do Not Disturb, or a number the user has blocked.
  `LOCAL_ENDED`
  This side hung up.
  `REMOTE_ENDED`
  The far end hung up.
  `UNANSWERED`
  It rang and nobody picked up.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static CallEndReason`
  `valueOf(String name)`
  Returns the enum constant of this type with the specified name.
  `static CallEndReason[]`
  `values()`
  Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, equals, getDeclaringClass, getEnumValues, hashCode, name, ordinal, setEnumValues, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### REMOTE_ENDED

    public static final CallEndReason REMOTE_ENDED
    The far end hung up.

  - ### LOCAL_ENDED

    public static final CallEndReason LOCAL_ENDED
    This side hung up.

  - ### UNANSWERED

    public static final CallEndReason UNANSWERED
    It rang and nobody picked up.

  - ### BUSY

    public static final CallEndReason BUSY
    The far end was busy.

  - ### FAILED

    public static final CallEndReason FAILED
    The call could not be set up -- no network, signalling failure, or a far end that never answered the invitation.

  - ### FILTERED

    public static final CallEndReason FILTERED
    The system, not the user, declined it: Do Not Disturb, or a number the user has blocked. Distinct from `UNANSWERED` because the call never rang.

- ## Method Details

  - ### values

    public static CallEndReason[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static CallEndReason valueOf(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null